// natives by Franc1sco franug


// Teams index
#define ZR_HUMANS 1
#define ZR_ZOMBIES 2
#define ZR_BOTH 3


/**
 * Add a Award to the main plugin.
 *
 * @param name            Award name.
 * @param price           Award Price.
 * @param teamallowed            Team allowed for use this award.
 * 
 * @noreturn			       
 */
native ZRShop_AddAward(const String:name[], price, teamallowed);

/**
 * Called when a Award has been bought.
 *
 * @param client            Client that bought the award.
 * @param price           Award Bought.		       
 */
forward ZRShop_OnAwardBought( client, const String:awardbought[]);

/**
 * Remove a Award to the main plugin.
 *
 * @param name            Award name.
 * 
 * @noreturn			       
 */
native ZRShop_RemoveAward(const String:name[]);


/**
 * Set credits to a client.
 *
 * @param client            Client target.
 * @param credits            Number of credit for set.
 * 
 * @noreturn			       
 */
native ZRShop_SetCredits(client, credits);

/**
 * Get credits client.
 *
 * @param client            Client target.
 * 
 * @return			        Return current credits of the target
 */
native ZRShop_GetCredits(client);

/**
 * Sent translations to the main plugin.
 *
 * @param client            File with translations.
 * 
 * @noreturn			       
 */
native ZRShop_LoadTranslations(const String:langfile[]); 
