#if defined _ncs_shop_included
	#endinput
#endif
#define _ncs_shop_included

// Definitions used in the basic plugin
// The changes will not affect the basic plugin
#define CPrefix						"\x04[\x05NCS SHOP\x04]\x01 %T"
#define MAX_STEAMID_LENGTH			32
#define MAX_SILVER_LENGTH			16
#define MAX_GOLD_LENGTH				16
#define MAX_SLOTS					16
#define MAX_ITEMS					256
#define MAX_ITEM_LENGTH				8
#define	MAX_ITEM_SHORTNAME_LENGTH	32
#define	MAX_ITEM_NAME_LENGTH		64
#define MAX_MENU_CMDS				32
#define MAX_MENU_CMD_LENGTH			192
#define MAX_CATEGORY				4
#define MAX_MENU_LENGTH				128
#define MAX_PLAYERS					MAXPLAYERS		//  -   ProcessTargetString

#define ALL_SLOTS					-1
#define SLOT_TRAILS					0
#define SLOT_SKINS					1
#define SLOT_HATS					2
#define SLOT_GR_TAILS				3
#define SLOT_GR_MODELS				4


//     
#define SLOT_SHORTNAME				0
#define SLOT_ENABLE					1
#define SLOT_FLAGS					2
#define SLOT_ITEMS					3
//     
#define ITEM_SHORTNAME				0
#define ITEM_PATH					1
#define ITEM_NAME					2
#define ITEM_SILVER					3
#define ITEM_GOLD					4
#define ITEM_TIME					5
#define ITEM_LUCK					6
#define ITEM_ORIGIN					7
#define ITEM_ANGLES					8
#define ITEM_SWIDTH					9
#define ITEM_EWIDTH					10
#define ITEM_LIFETIME				11
#define ITEM_TEAM					12
#define ITEM_COLOR					13
#define ITEM_BONUSES				14
#define ITEM_LAST					14

#define FSLOT_NONE					0			/*   */
#define FSLOT_CREATEALL				(1 << 0)	/*    */
#define FSLOT_TEAMS					(1 << 1)	/*    */
#define FSLOT_NOPATH				(1 << 2)	/*     / */

/**
 *  "  ?".
 */
enum ShowItems
{
	ShowItems_All = 0,		/**<    */	
	ShowItems_Nothing,		/**<    */
	ShowItems_Strangers,	/**<    */
};




/**
 * ,    "".
 *
 * @param client		 .
 * @param menu			Handle .
 * @return				>= Plugin_Handled,    ;
 *						>= Plugin_Stop,   CloseHandle(menu).
 */
forward Action:SHOP_OnBuildMenuShop(client, Handle:menu);

/**
 * Handler SHOP_OnBuildMenuShop
 *
 * @param menu			 Menu Handler .
 * @return				>= Plugin_Handled,    "" Handler-;
 *						>= Plugin_Stop,   CloseHandle(menu).
 */
forward Action:SHOP_HandlerMenuShop(Handle:menu, MenuAction:action, param, param2);

/**
 * ,    " ".
 *
 * @param client		 .
 * @param menu			Handle .
 * @return				>= Plugin_Handled,    ;
 *						>= Plugin_Stop,   CloseHandle(menu).
 */
forward Action:SHOP_OnBuildMenuLuck(client, Handle:menu);

/**
 * Handler SHOP_OnBuildMenuLuck
 *
 * @param menu			 Menu Handler .
 * @return				>= Plugin_Handled,    "" Handler-;
 *						>= Plugin_Stop,   CloseHandle(menu).
 */
forward Action:SHOP_HandlerMenuLuck(Handle:menu, MenuAction:action, param, param2);

/**
 * ,    " "
 *
 * @param client		 .
 * @return				Plugin_Handled,    .
 */
forward Action:SHOP_OnLuckGameStarted(client);

/**
 * ,    "".
 *
 * @param client		 .
 * @param menu			Handle .
 * @return				>= Plugin_Handled,    ;
 *						>= Plugin_Stop,   CloseHandle(menu).
 */
forward Action:SHOP_OnBuildMenuSettings(client, Handle:menu);

/**
 * Handler SHOP_OnBuildMenuSettings
 *
 * @param menu			 Menu Handler .
 * @return				>= Plugin_Handled,    "" Handler-;
 *						>= Plugin_Stop,   CloseHandle(menu).
 */
forward Action:SHOP_HandlerMenuSettings(Handle:menu, MenuAction:action, param, param2);

/**
 *    .
 *
 * :    ,
 *  "item_default" .
 *
 * @param client		 .
 * @param slot			  .
 * @param item			ID  .
 * @noreturn
 */
forward SHOP_ItemPurchased(client, slot, item, time);

/**
 *    .
 *
 * @param client		 .
 * @param slot			  .
 * @param id			ID  .
 * @noreturn
 */
forward SHOP_ItemCreated(client, slot, id);

/**
 *    .
 *
 * @param client		 .
 * @noreturn
 */
forward SHOP_PlayerSpawned(client);

/**
 *    
 *    .
 *
 * @param client		 .
 * @param silver		 .
 * @return				>= Plugin_Handled,   .
 */
forward Action:SHOP_OnPlayerGetMapGift(client, &silver);

/**
 *    
 *    .
 *
 * @param client		 .
 * @param silver		 .
 * @noreturn
 */
forward SHOP_PlayerGetMapGift(client, silver);

/**
 *     ().
 *
 * @param entity		 .
 * @noreturn
 */
forward SHOP_OnMapGiftEntityCreated(entity);

/**
 *     .
 *
 * @noreturn
 */
forward SHOP_OnAllConfigsLoaded();

/**
 *      .
 *
 * : gravity   trigger_gravity 
 * ,     .
 *
 * @param client		 .
 * @param result		.
 * @param gravity		,   
 *						  result.
 * @return				>= Plugin_Handled,    result gravity.
 */
forward Action:SHOP_OnGetClientGravity(client, &Float:result, const Float:gravity);

/**
 *     (index & IsClientConnected() & IsClientInGame()).
 *
 * @param client		 .
 * @param alive			    (false ).
 * @param bots			   (false ).
 * @return				True   , false .
 */
native bool:SHOP_IsValidPlayer(client, bool:alive = false, bool:bots = false);

/**
 *   ,   .
 *
 * @return				ADMFLAG_*.
 */
native SHOP_GetAdminFlag();

/**
 *    ,   .
 *
 * @return				ADMFLAG_*.
 */
native SHOP_GetAdminFlagRoot();

/**
 *     ,
 *   .
 *
 * @return				 .
 */
native SHOP_GetHideAdminMSG();

/**
 *       ID.
 *
 * @param shortname		  .
 * @param enable		  .
 * @param flags			 .
 * @return				True   , false .
 */
native bool:AddSlot(const String:shortname[], bool:enable = true, flags = FSLOT_NONE);

/**
 *  ID     .
 *
 * @param client		 .
 * @param slot			 .
 * @param category		  (   FSLOT_TEAMS; 2 - T, 3 - CT).
 * @return				ID .
 */
native GetDefaultItem(client, slot, category = 0);

/**
 *        .
 *
 * @param client		 .
 * @param slot			 .
 * @return				 .
 */
native GetItemEntity(client, slot);

/**
 *       
 * defvalue,      .
 *
 * @param section		.
 * @param key			.
 * @param defvalue		 .
 * @return				 .
 */
native GetCFGValue(const String:section[], const String:key[], defvalue = 0);

/**
 *       
 *   defvalue,      .
 *
 * @param section		.
 * @param key			.
 * @param defvalue		 .
 * @return				   .
 */
native Float:GetCFGValueFloat(const String:section[], const String:key[], Float:defvalue = 0.0);

/**
 *       
 * defvalue,      .
 *
 * @param section		.
 * @param key			.
 * @param buffer		    .
 * @param maxlength		   .
 * @param defvalue		 .
 * @return				True   , false 
 *						("ERROR" -  ,    ;
 *						defvalue -    ).
 */
native bool:GetCFGValueString(const String:section[], const String:key[], String:buffer[], maxlength, const String:defvalue[] = "");

/**
 *   .
 *
 * @param slot			 .
 * @param index			ID .
 * @param option		 (.  define).
 * @return				 .
 */
native GetItemOption(slot, index, option);

/**
 *    ,  ITEM_ORIGIN  ITEM_ANGLES.
 *
 * @param slot			 .
 * @param index			ID .
 * @param option		 (.  define).
 * @param output		 .
 * @return				  .
 */
native GetItemOptionVector(slot, index, option, Float:output[3]);

/**
 *    ,  ITEM_COLOR.
 *
 * @param slot			 .
 * @param index			ID .
 * @param option		 (.  define).
 * @param output		 .
 * @return				  .
 */
native GetItemOptionColor(slot, index, option, output[4]);

/**
 *   .
 *
 * @param client		 .
 * @param amount		 .
 * @noreturn
 */
native SetSilver(client, amount);

/**
 *   .
 *
 * @param client		 .
 * @return				 .
 */
native GetSilver(client);

/**
 *   .
 *
 * @param client		 .
 * @param amount		 .
 * @noreturn
 */
native SetGold(client, amount);

/**
 *   .
 *
 * @param client		 .
 * @return				 .
 */
native GetGold(client);

/**
 *     .
 *
 * @param client		 .
 * @param buffer		   .
 * @param maxlength		   .
 * @noreturn
 */
native GetFormatMoney(client, String:buffer[], maxlength);

/**
 *       .
 *
 * @param client		 .
 * @param flags			  .
 * @return				True   , false .
 */
native bool:HasAdminFlags(client, flags = ADMFLAG_GENERIC);

/**
 *     ,
 *   .
 *
 * @param client		 .
 * @return				 .
 */
native GetClientMaxHP(client);

/**
 *    
 *    .
 *
 * @param client		 .
 * @param slot			 .
 * @param setting		 .
 * @noreturn
 */
native SetClientSetting(client, slot, ShowItems:setting);

/**
 *    
 *    .
 *
 * @param client		 .
 * @param slot			 .
 * @return				ShowItems .
 */
native ShowItems:GetClientSetting(client, slot);

/**
 *     .
 *
 * @param client		 .
 * @param amount		 .
 * @noreturn
 */
native SetMaxSpeed(client, Float:amount);

/**
 *     .
 *
 * @param client		 .
 * @return				  .
 */
native Float:GetMaxSpeed(client);

/**
 *   .
 *
 * @param client		 .
 * @param amount		 .
 * @noreturn
 */
native SetSpeed(client, Float:amount);

/**
 *   .
 *
 * @param client		 .
 * @return				 
 */
native Float:GetSpeed(client);

/**
 *   "".
 *
 * @param client		 .
 * @return				True   , false .
 */
native bool:SHOP_DisplayMenuShop(client);
#pragma deprecated Use SHOP_DisplayMenuShop() instead
native Handle:SHOP_BuildMenuShop(client);	// return bool:

public SharedPlugin:__pl_ncs_shop = 
{
	name = "ncs_shop",
	file = "ncs_shop.smx",
#if defined REQUIRE_PLUGIN
	required = 1,
#else
	required = 0,
#endif
};

#if !defined REQUIRE_PLUGIN
public __pl_ncs_shop_SetNTVOptional()
{
	MarkNativeAsOptional("SHOP_IsValidPlayer");
	MarkNativeAsOptional("SHOP_GetAdminFlag");
	MarkNativeAsOptional("SHOP_GetAdminFlagRoot");
	MarkNativeAsOptional("SHOP_GetHideAdminMSG");
	MarkNativeAsOptional("SHOP_BuildMenuShop");
	MarkNativeAsOptional("SHOP_DisplayMenuShop");
	
	MarkNativeAsOptional("AddSlot");
	MarkNativeAsOptional("GetDefaultItem");
	MarkNativeAsOptional("GetCFGValue");
	MarkNativeAsOptional("GetCFGValueFloat");
	MarkNativeAsOptional("GetCFGValueString");
	MarkNativeAsOptional("GetItemOption");
	MarkNativeAsOptional("GetItemOptionVector");
	MarkNativeAsOptional("GetItemOptionColor");
	MarkNativeAsOptional("SetSilver");
	MarkNativeAsOptional("GetSilver");
	MarkNativeAsOptional("SetGold");
	MarkNativeAsOptional("GetGold");
	MarkNativeAsOptional("GetFormatMoney");
	MarkNativeAsOptional("GetClientMaxHP");
	MarkNativeAsOptional("SetClientSetting");
	MarkNativeAsOptional("GetClientSetting");
	MarkNativeAsOptional("SetMaxSpeed");
	MarkNativeAsOptional("GetMaxSpeed");
	MarkNativeAsOptional("SetSpeed");
	MarkNativeAsOptional("GetSpeed");
	
	MarkNativeAsOptional("HasAdminFlags");
}
#endif