/**
 * =============================================================================
 * Autobalance Blocker
 * Copyright (C) 2011 Afronanny. All rights reserved.
 * =============================================================================
 *
 * This program is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, version 3.0, as published by the
 * Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
 * details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program.  If not, see <http://www.gnu.org/licenses/>.
 */


 /**
 * @brief Called when the balancer wants to know if a player can be autobalanced
 *
 * @param client	Index of the client
 * @param actual	Result as determined by the server. Overwrite and return Plugin_Handled to force a value.
 * @return 		True to allow player to be seen, false to disallow player being seen
 */
forward Action:OnBalanceCheck(client, &bool:actual);



public Extension:__ext_teambalanceimmunity =
{
	name = "Team Balance Immunity",
	file = "teambalanceimmunity.ext",
#if defined AUTOLOAD_EXTENSIONS
	autoload = 1,
#else
	autoload = 0,
#endif
#if defined REQUIRE_EXTENSIONS
	required = 1,
#else
	required = 0,
#endif
};

